% Exercise 5

close all
clearvars
clc

% Generate the signal x(n) = u(n-5) - u(n-10), 
% considering n = 1:15.
% Generate the periodic signal xp(n) with period N = 15, 
% considering n = 1:200.
% Hint: Consider using repmat instead of for loops.

%% define one period of the signal

N = 15; % period
n = 1:N;
x = zeros(1, N);
x(n>= 5 & n <10) = 1;

%% create the periodic signal

n_max = 200;

% how many signal periods until n_max?
% N_p is the nearest integer greater than or equal to n_max/N
N_p = ceil(n_max / N); 

% create the periodic signal until N_p periods
% repmat(x, #repetitions on rows, #repetitions on columns)
% for details, see: https://it.mathworks.com/help/matlab/ref/repmat.html
x_p = repmat(x, 1, N_p);

x_p = x_p(1:n_max);

%% plot the signal considering only 8 periods

figure;
stem(x);
ll{1} = 'x(n)';
hold on;
stem(x_p(1: N*8), '--');
ll{2} = 'x_p(n)';
legend(ll, 'fontsize', 14);


